Index: comments.c
===================================================================
--- comments.c	(revision 1816)
+++ comments.c	(working copy)
@@ -290,12 +290,14 @@
 int delete_all_host_comments(char *host_name) {
 	int result = OK;
 	comment *temp_comment = NULL;
+	comment *next_comment = NULL;
 
 	if(host_name == NULL)
 		return ERROR;
 
 	/* delete host comments from memory */
-	for(temp_comment = get_first_comment_by_host(host_name); temp_comment != NULL; temp_comment = get_next_comment_by_host(host_name, temp_comment)) {
+	for(temp_comment = get_first_comment_by_host(host_name); temp_comment != NULL; temp_comment = next_comment) {
+                next_comment = get_next_comment_by_host(host_name, temp_comment);
 		if(temp_comment->comment_type == HOST_COMMENT)
 			delete_comment(HOST_COMMENT, temp_comment->comment_id);
 		}
